package com.zsc.edu.gateway.framework.message.websocket;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.socket.config.annotation.EnableWebSocket;
import org.springframework.web.socket.config.annotation.WebSocketConfigurer;
import org.springframework.web.socket.config.annotation.WebSocketHandlerRegistry;

/**
 * @author zhuang
 */
@Configuration
@EnableWebSocket
public class WebSocketConfig implements WebSocketConfigurer {

    private final GenericWebSocketHandler genericWebSocketHandler;

    public WebSocketConfig(GenericWebSocketHandler genericWebSocketHandler) {
        this.genericWebSocketHandler = genericWebSocketHandler;
    }

    @Override
    public void registerWebSocketHandlers(WebSocketHandlerRegistry registry) {
        registry.addHandler(genericWebSocketHandler, "/api/rest/device/ws/device/status", "/api/rest/device/ws/record/status", "/api/rest/product/ws/product/status")
                .setAllowedOrigins("*")
                .addInterceptors(new WebSocketInterceptor());
    }
}